/*
ローカルPCでの動作確認用の簡易httpサーバ
使い方
document_root(規定値はweb/)以下にhtml等のリソース配置
node httpd.js で起動
ブラウザで
http://127.0.0,1
でアクセス。
他のpcから見る場合はこれを動かしているpcで
ipconfigコマンド等でローカルipを取得してそこにアクセスする。
その場合ファイアウォール設定が必要になる。
*/

const port=80;
const fs = require('fs');
const http = require("http");
const document_root = "web/";//webコンテンツファイルの実際の配置場所指定
const server = http.createServer((request, response) => {
  console.log(request.url);
  const url = request.url;
  const path = require('path');
  const info = path.parse(url);
  const local_path = document_root+url.substr(1);
  
  if(url=="/" ){
    response.writeHead(200,{
      "Content-Type": "text/html"
    });
    const data = fs.readFileSync(document_root+"index.html");
    response.end(data);
  }else if(url.endsWith("/")){
    response.writeHead(200,{
      "Content-Type": "text/html"
    });
    const data = fs.readFileSync(local_path+"index.html");
    response.end(data);
  }else if(!fs.existsSync(local_path)){
    //ない場合
    response.writeHead(404);
    response.end();
  } else if(info.ext==".js"){
    response.writeHead(200,{
      "Content-Type": "application/javascript"
    });
    const data = fs.readFileSync(local_path);
    response.end(data);
  }else if(info.ext==".ico"){
    response.writeHead(200,{
      "Content-Type": "image/vnd.microsoft.icon"
    });
    const data = fs.readFileSync(local_path);
    response.end(data);
  }else if(info.ext==".png"){
    response.writeHead(200,{
      "Content-Type": "image/png"
    });
    const data = fs.readFileSync(local_path);
    response.end(data);
  }else if(info.ext==".png"){
    response.writeHead(200,{
      "Content-Type": "image/png"
    });
    const data = fs.readFileSync(local_path);
    response.end(data);
  }else if(info.ext==".jpg" || info.ext==".jpeg"){
    response.writeHead(200,{
      "Content-Type": "image/jpeg"
    });
    const data = fs.readFileSync(local_path);
    response.end(data);

  }else if(info.ext==".html"){
    response.writeHead(200,{
      "Content-Type": "text/html"
    });
    const data = fs.readFileSync(local_path);
    response.end(data);
  }else{
    response.writeHead(200,{
      "Content-Type": "application/octet-stream"
    });
    const data = fs.readFileSync(local_path);
    response.end(data);
  }
});

server.listen(port);