

export const textAsync = async (message_text,data,param={ok:'ＯＫ'}) => {
//大き目のテキストをだすための
        let dialog = document.createElement('dialog');
        dialog.style.resize = "both";
        dialog.style.width = "fit-content";
        dialog.style.height = "fit-content";
        
        if(param.dialog_class){
          dialog.className = param.dialog_class;
        }
        let message = document.createElement('p');
        message.textContent = message_text;
        if(param.message_class){
          message.className = param.message_class;
        }
        dialog.appendChild(message);

        let ta = document.createElement('textarea');
        ta.readonly = true;
        if(param.cols){
          ta.cols=param.cols;
        }else{
          ta.cols=40;
        }
        if(param.rows){
          ta.rows=param.rows;
        }else{
          ta.rows=5;
        }
        ta.value = data;
        dialog.appendChild(ta);
        
        if(param.copy){
          let copy_button = document.createElement('button');
          copy_button.textContent = param.copy;
          if(param.copy_class){
            copy_button.className = param.copy_class;
          }
          copy_button.onclick = () =>{
            navigator.clipboard.writeText(data);
            if(param.copy_message){
              alert(param.copy_message);
            }else{
              alert("コピーしました");
            }
          };
          dialog.appendChild(copy_button);
        }
        
        let ok_button = document.createElement('button');
        ok_button.textContent = param.ok;
        if(param.ok_class){
          ok_button.className = param.ok_class;
        }
        dialog.appendChild(ok_button);
        document.body.appendChild(dialog);;
        dialog.showModal();
        return new Promise(resolve => {
          const eventBase = flag => () => {
            dialog.close();
            ok_button.removeEventListener("click", okEvent);
            document.body.removeChild(dialog);
            resolve(flag);
          };
          const okEvent = eventBase(true);
          ok_button.addEventListener("click", okEvent);
        });
      };



export const alertAsync = async (message_text,param={ok:'ＯＫ'}) => {
        let dialog = document.createElement('dialog');
        if(param.dialog_class){
          dialog.className = param.dialog_class;
        }
        let message = document.createElement('p');
        message.textContent = message_text;
        if(param.message_class){
          message.className = param.message_class;
        }
        dialog.appendChild(message);
        let ok_button = document.createElement('button');
        ok_button.textContent = param.ok;
        if(param.ok_class){
          ok_button.className = param.ok_class;
        }
        dialog.appendChild(ok_button);
        document.body.appendChild(dialog);;
        dialog.showModal();
        return new Promise(resolve => {
          const eventBase = flag => () => {
            dialog.close();
            ok_button.removeEventListener("click", okEvent);
            document.body.removeChild(dialog);
            resolve(flag);
          };
          const okEvent = eventBase(true);
          ok_button.addEventListener("click", okEvent);
        });
      };

export const confirmAsync = async (message_text,param={}) => {
        let dialog = document.createElement('dialog');
        if(param.dialog_class){
          dialog.className = param.dialog_class;
        }
        let message = document.createElement('p');
        message.textContent = message_text;
        if(param.message_class){
          message.className = param.message_class;
        }
        dialog.appendChild(message);
        let ok_button = document.createElement('button');
        if("ok" in param){
          ok_button.textContent = param.ok;
        }else{
          ok_button.textContent = "ＯＫ";
        }
        if(param.ok_class){
          ok_button.className = param.ok_class;
        }
        dialog.appendChild(ok_button);
        let cancel_button = document.createElement('button');
        if("cancel" in param){
          cancel_button.textContent = param.cancel;
        }else{
          cancel_button.textContent = "キャンセル";
        }
        if(param.cancel_class){
          cancel_button.className = param.cancel_class;
        }
        //nocancel=true指定の場合はキャンセル出さない
        if(!param.nocancel){
          dialog.appendChild(cancel_button);
        }

        document.body.appendChild(dialog);;
        dialog.showModal();
        return new Promise(resolve => {
          let timeout_id = null;
          const eventBase = flag => () => {
            dialog.close();
            if(timeout_id!=null){
              clearTimeout(timeout_id);
            }
            ok_button.removeEventListener("click", okEvent);
            cancel_button.removeEventListener("click", cancelEvent);
            document.body.removeChild(dialog);
            resolve(flag);
          };
          const okEvent = eventBase(true);
          const cancelEvent = eventBase(false);

          ok_button.addEventListener("click", okEvent);
          cancel_button.addEventListener("click", cancelEvent);

          if(param.timeout_ms){
            let timeout_event = eventBase(param.timeout_val);
            timeout_id = setTimeout(()=>{
              timeout_event();
            },param.timeout_ms);
          }
        });
      };

export const choiceAsync = async (message_text,param={}) => {
        let dialog = document.createElement('dialog');
        if(param.dialog_class){
          dialog.className = param.dialog_class;
        }
        let message = document.createElement('p');
        message.textContent = message_text;
        if(param.message_class){
          message.className = param.message_class;
        }
        dialog.appendChild(message);
        let buttons = [];
        for(let btn of param.buttons){
          let button = document.createElement('button');
          button.textContent = btn.caption;
          button._value = btn.value;
          if(btn.class){
            button.className = btn.class;
          }
          buttons.push(button);

          let br = document.createElement('br');
          dialog.appendChild(br);
          dialog.appendChild(button);
        }
        document.body.appendChild(dialog);;
        dialog.showModal();
        return new Promise(resolve => {
          let timeout_id = null;
          const eventBase = choice => () => {
            dialog.close();
            if(timeout_id!=null){
              clearTimeout(timeout_id);
            }
            for(let button of buttons){
              button.removeEventListener("click", button.okEvent);
            }
            document.body.removeChild(dialog);
            resolve(choice);
          };
          for(let button of buttons){
            button.okEvent = eventBase(button._value);
            button.addEventListener("click", button.okEvent);
          }
          if(param.timeout_ms){
            let timeout_event = eventBase(param.timeout_val);
            timeout_id = setTimeout(()=>{
              timeout_event();
            },param.timeout_ms);
          }
        });
      };



export const promptAsync = async (message_text,param={}) => {
        let dialog = document.createElement('dialog');
        if(param.dialog_class){
          dialog.className = param.dialog_class;
        }
        let message = document.createElement('p');
        message.textContent = message_text;
        if(param.message_class){
          message.className = param.message_class;
        }
        dialog.appendChild(message);
        
        let input = document.createElement('input');
        if(param.placeholder){
          input.placeholder = param.placeholder;
        }
        if(param.default_value){
          input.value = param.default_value;
        }
        if(param.input_class){
          input.className = param.input_class;
        }
        dialog.appendChild(input);


        let ok_button = document.createElement('button');
        if("ok" in param){
          ok_button.textContent = param.ok;
        }else{
          ok_button.textContent = "ＯＫ";
        }
        if(param.ok_class){
          ok_button.className = param.ok_class;
        }
        dialog.appendChild(ok_button);
        ok_button.disabled = (!param.default_value);
        input.oninput = () =>{
          ok_button.disabled = (input.value=="");
        }
        
        
        let cancel_button = document.createElement('button');
        if("cancel" in param){
          cancel_button.textContent = param.cancel;
        }else{
          cancel_button.textContent = "キャンセル";
        }
        if(param.cancel_class){
          cancel_button.className = param.cancel_class;
        }
        //nocancel=true指定の場合はキャンセル出さない
        if(!param.nocancel){
          dialog.appendChild(cancel_button);
        }
        
        document.body.appendChild(dialog);;
        dialog.showModal();
        return new Promise(resolve => {
          let timeout_id = null;
          const eventBase = flag => () => {
            //空入力でokした場合はキャンセル可能ならキャンセル扱い
            //そうでない場合は無視
            if(flag==true && input.value==""){
              if(param.nocancel){
                return;
              }else{
                flag = false;
              }
            }
          
            dialog.close();
            if(timeout_id!=null){
              clearTimeout(timeout_id);
            }
            ok_button.removeEventListener("click", okEvent);
            cancel_button.removeEventListener("click", cancelEvent);
            document.body.removeChild(dialog);
            if(flag==true){
              resolve(input.value);
            }else if(flag==false){
              resolve(false);
            }else{
              resolve(flag);
            }
          };
          const okEvent = eventBase(true);
          const cancelEvent = eventBase(false);

          ok_button.addEventListener("click", okEvent);
          cancel_button.addEventListener("click", cancelEvent);
          //promptのタイムアウトは単に隠し規定値でしかない
          if(param.timeout_ms){
            let timeout_event = eventBase(param.timeout_val);
            timeout_id = setTimeout(()=>{
              timeout_event();
            },param.timeout_ms);
          }

        });
      };


export const sliderAsync = async (message_text,param={}) => {
        let dialog = document.createElement('dialog');
        if(param.dialog_class){
          dialog.className = param.dialog_class;
        }
        let message = document.createElement('p');
        message.textContent = message_text;
        if(param.message_class){
          message.className = param.message_class;
        }
        dialog.appendChild(message);
        
        let input = document.createElement('input');
        input.type="range";

        if(param.step_value){
          input.step = param.step_value;
        }else{
          input.step = 0.01;
        }

        if(param.min_value){
          input.min = param.min_value;
        }else{
          input.min = 0;
        }
        if(param.max_value){
          input.max = param.max_value;
        }else{
          input.max = 1;
        }

        
        if(param.default_value){
          input.value = 1.0*param.default_value;
        }else{
          input.value = 0;
        }

        if(param.input_class){
          input.className = param.input_class;
        }

        if(param.on_input){
          input.addEventListener(`input`,async ()=>{
            param.on_input(input.value);
          });
        };
        
        dialog.appendChild(input);


        let ok_button = document.createElement('button');
        if("ok" in param){
          ok_button.textContent = param.ok;
        }else{
          ok_button.textContent = "ＯＫ";
        }
        if(param.ok_class){
          ok_button.className = param.ok_class;
        }
        dialog.appendChild(ok_button);

        
        let cancel_button = document.createElement('button');
        if("cancel" in param){
          cancel_button.textContent = param.cancel;
        }else{
          cancel_button.textContent = "キャンセル";
        }
        if(param.cancel_class){
          cancel_button.className = param.cancel_class;
        }
        //nocancel=true指定の場合はキャンセル出さない
        if(!param.nocancel){
          dialog.appendChild(cancel_button);
        }
        
        document.body.appendChild(dialog);;
        dialog.showModal();
        return new Promise(resolve => {
          let timeout_id = null;
          const eventBase = flag => () => {
            //空入力でokした場合はキャンセル可能ならキャンセル扱い
            //そうでない場合は無視
            if(flag==true && input.value==""){
              if(param.nocancel){
                return;
              }else{
                flag = false;
              }
            }
          
            dialog.close();
            if(timeout_id!=null){
              clearTimeout(timeout_id);
            }
            ok_button.removeEventListener("click", okEvent);
            cancel_button.removeEventListener("click", cancelEvent);
            document.body.removeChild(dialog);
            if(flag==true){
              resolve(input.value);
            }else if(flag==false){
              resolve(false);
            }
          };
          const okEvent = eventBase(true);
          const cancelEvent = eventBase(false);

          ok_button.addEventListener("click", okEvent);
          cancel_button.addEventListener("click", cancelEvent);
          //promptのタイムアウトは単に隠し規定値でしかない
          if(param.timeout_ms){
            let timeout_event = eventBase(param.timeout_val);
            timeout_id = setTimeout(()=>{
              timeout_event();
            },param.timeout_ms);
          }

        });
      };

